<?php

/**
 * @package     Joomla.Plugin
 * @subpackage  Editors.switcher
 *
 * @copyright   (C) 2023 Open Source Matters, Inc. <https://www.joomla.org>
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\CMS\Extension\PluginInterface;
use Joomla\CMS\Factory;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\DI\Container;
use Joomla\DI\ServiceProviderInterface;
use Joomla\Event\DispatcherInterface;
use Joomla\Plugin\Editors\Switcher\Extension\Switcher;

return new class () implements ServiceProviderInterface {
	/**
	 * Registers the service provider with a DI container.
	 *
	 * @param   Container  $container  The DI container.
	 *
	 * @return  void
	 *
	 * @since   4.3.0
	 */
	public function register(Container $container)
	{
		$container->set(
			PluginInterface::class,
			function (Container $container) {
				$dispatcher = $container->get(DispatcherInterface::class);
				//Hummmmmmm There is an environment where namespace does not work.
				class_exists('Switcher') or require_once(JPATH_PLUGINS . '/editors/switcher/src/Extension/switcher.php');

				$plugin     = new Switcher(
					$dispatcher,
					(array) PluginHelper::getPlugin('editors', 'switcher')
				);
				$plugin->setApplication(Factory::getApplication());

				return $plugin;
			}
		);
	}
};